package net.wanji.web.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import net.wanji.feign.pojo.result.JsonViewObject;
import net.wanji.web.dto.CrossIdDTO;
import net.wanji.web.dto.CrossIdAndPhaseIdDTO;
import net.wanji.web.dto.ScheduleIdDTO;
import net.wanji.web.dto.SchemeIdDTO;
import net.wanji.web.service.impl.SchemeSendServiceImpl;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author hanbing
 * @date 2023/01/04 16:10
 */
@Api(value = "PlanSendController", description = "方案下发")
@RequestMapping("/planSend")
@RestController
@SuppressWarnings("all")
public class PlanSendController {
    private final SchemeSendServiceImpl schemeSendService;

    public PlanSendController(SchemeSendServiceImpl schemeSendService) {
        this.schemeSendService = schemeSendService;
    }

    @ApiOperation(value = "方案下发", notes = "时间表下发")
    @PostMapping("/scheduleSend")
    public JsonViewObject timeTableSend(@RequestBody ScheduleIdDTO scheduleIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.scheduleSend(scheduleIdDTO);
        return jsonViewObject;
    }

    @ApiOperation(value = "强制方案", notes = "强制方案")
    @PostMapping("/schemeSend")
    public JsonViewObject schemeSend(@RequestBody SchemeIdDTO schemeIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.schemeSend(schemeIdDTO);
        return jsonViewObject;
    }

    @ApiOperation(value = "模式切换-中心控制-步进", notes = "模式切换-中心控制-步进")
    @PostMapping("/nextStep")
    public JsonViewObject nextStep(@RequestBody CrossIdDTO crossIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.nextStep(crossIdDTO);
        return jsonViewObject;
    }

    @ApiOperation(value = "模式切换-中心控制-相位锁定", notes = "模式切换-中心控制-相位锁定")
    @PostMapping("/lockPhase")
    public JsonViewObject lockPhase(@RequestBody CrossIdAndPhaseIdDTO crossIdAndPhaseIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.lockPhase(crossIdAndPhaseIdDTO);
        return jsonViewObject;
    }

    @ApiOperation(value = "模式切换-中心控制-全红控制", notes = "模式切换-中心控制-全红控制")
    @PostMapping("/allRedControl")
    public JsonViewObject allRedControl(@RequestBody CrossIdDTO crossIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.allRedControl(crossIdDTO);
        return jsonViewObject;
    }

    @ApiOperation(value = "模式切换-中心控制-黄闪控制", notes = "模式切换-中心控制-黄闪控制")
    @PostMapping("/yellowLightControl")
    public JsonViewObject yellowLightControl(@RequestBody CrossIdDTO crossIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.yellowLightControl(crossIdDTO);
        return jsonViewObject;
    }

    @ApiOperation(value = "模式切换-中心控制-恢复", notes = "模式切换-中心控制-恢复")
    @PostMapping("/restore")
    public JsonViewObject restore(@RequestBody CrossIdAndPhaseIdDTO crossIdAndPhaseIdDTO) {
        JsonViewObject jsonViewObject = schemeSendService.restore(crossIdAndPhaseIdDTO);
        return jsonViewObject;
    }

}
